(C) Copyright Zhi-Ping Liu zpliu@amss.ac.cn

###################################
# This version of the program is in very preliminary stage and provided just for testing purpose. The program is still under development.
# You can modify it to more complicated and elegant.
# 
# Enjoy Coding :)
--------------------------------------------------

library(igraph)
library(lattice)
library(Matrix)
library(quadprog)
library(lpSolve)
library(limSolve)

dat<-read.table(file='exp.net',sep=',') # modification
dat<-dat[,2:3]
gra<-graph.data.frame(data.frame(dat),directed=T)

adj<-get.adjacency(gra)
gene<-rownames(adj)
dat<-read.table(file='exp',sep=',') # modification

rownames(dat)<-dat[,1]
colnames(dat)<-paste("T",1:dim(dat)[2]-1,sep = "")

dat<-dat[,2:dim(dat)[2]]

exp<-c()
for (i in 1:length(gene)){
    exp<-rbind(exp,dat[gene[i],])
    }

dat<-exp
dat <- as.matrix(dat)

n <- dim(dat)[2] # nb of time points
p <- dim(dat)[1] # nb of genes

y = dat[,2:n]
x = dat[,1:n-1]

a = t(adj)

nnrow<-c()
nncol<-c()

adr <- c()
adc <- c()

ydr <- c()
xdr <- c()

for (i in 1:dim(a)[1]){
    if (sum(a[i,])!=0){
        adr <- rbind(adr,a[i,])
        ydr <- rbind(ydr,y[i,])
        nnrow <- c(nnrow,rownames(a)[i])}
    }

for (j in 1:dim(adr)[2]){
    if (sum(adr[,j])!=0){
       adc <-cbind(adc,adr[,j])
       xdr <-rbind(xdr,x[j,])
       nncol <- c(nncol,colnames(a)[j])}
    }

a<-adc

rownames(a)<-nnrow
colnames(a)<-nncol

y<-ydr

x<-xdr

p<-dim(a)[1]

#----
for (j in 1:dim(a)[2]){
    if (substr(colnames(a)[j],1,4)=="hsa-"){
               a[,j]=-a[,j]}
     }

#----
A <- t(kronecker(Diagonal(p),x))
B <- as.matrix(as.vector(t(y)))
xx <- as.matrix(as.vector(t(a)))

#-----

Ieq <- which(xx==0)

if (length(Ieq)==0){
E <- NULL
F <- NULL
}else {
E <- matrix(0,nrow=length(Ieq),ncol=dim(xx)[1])
j = 0
for (i in 1:dim(xx)[1])
{
if (xx[i,1]==0){
j = j + 1
E[j,i] <- 1
}
}

E<-as.matrix(E)
F <- as.matrix(rep(0,dim(E)[1]))
}

Igr <-which (xx==-1)

if (length(Igr)==0){
G<-NULL
H<-NULL
} else {
G<-c()
for (i in 1:dim(xx)[1])
{
if (xx[i,1]==-1){
Gvec <-rep(0,dim(xx)[1])
Gvec[i] <- -1
G<-rbind(G,Gvec)
}
}
G<-as.matrix(G)
H <- as.matrix(rep(0,dim(G)[1]))
}

#------
II <- as.matrix(cbind(diag(dim(xx)[1]),-diag(dim(xx)[1])))

Dmat  <- t(II) %*% t(A) %*% A %*% II
diag(Dmat) <- diag(Dmat)+1e-8
Tol <- sqrt(.Machine$double.eps)

if (!is.null(E)){
E <- E %*% II}

if (!is.null(G)){
G <- G %*% II}

Amat  <- t(rbind(E, G, diag(2*dim(xx)[1])))

G2 <- as.matrix(rep(0,2*dim(xx)[1]))

bvec  <- c(F,H,G2)

if (!is.null(E)){
Neq <- dim(E)[1]
} else {
Neq <- 0
}

lambdamax <- 2*max(abs(t(A) %*% B))

lambda <- seq(0,lambdamax,lambdamax/10) # modification 10

predres <- c()

###### selecting lambda

for (i in 1:length(lambda)){

predresj = 0

for (j in 2:dim(dat)[2]){

datt <- dat[,-j]
expjtime <- as.matrix(dat[,j])
expj1time <- as.matrix(dat[,j-1])

nt <- dim(datt)[2]
pt <- dim(datt)[1]

yt = datt[,2:nt]
xt = datt[,1:nt-1]

at = t(adj)

nnrowt<-c()
nncolt<-c()

adrt <- c()
adct <- c()

ydrt <- c()
xdrt <- c()

for (m in 1:dim(at)[1]){
    if (sum(at[m,])!=0){
        adrt <- rbind(adrt,at[m,])
        ydrt <- rbind(ydrt,yt[m,])
        nnrowt <- c(nnrowt,rownames(at)[m])}
    }

for (n in 1:dim(adrt)[2]){
    if (sum(adrt[,n])!=0){
       adct <-cbind(adct,adrt[,n])
       xdrt <-rbind(xdrt,xt[n,])
       nncolt <- c(nncolt,colnames(at)[n])}
    }

at<-adct

rownames(at)<-nnrowt
colnames(at)<-nncolt

yt<-ydrt

xt<-xdrt

pt<-dim(at)[1]

#----
for (m in 1:dim(at)[2]){
    if (substr(colnames(at)[m],1,4)=="hsa-"){
               at[,m]=-at[,m]}
     }

#----
At <- t(kronecker(Diagonal(pt),xt))
Bt <- as.matrix(as.vector(t(yt)))
xxt <- as.matrix(as.vector(t(at)))

#-----
Ieqt <- which(xxt==0)

if (length(Ieqt)==0){
Et <- NULL
Ft <- NULL
}else {
Et <- matrix(0,nrow=length(Ieqt),ncol=dim(xxt)[1])
n = 0
for (m in 1:dim(xxt)[1])
{
if (xxt[m,1]==0){
n = n + 1
Et[n,m] <- 1
}
}

Et<-as.matrix(Et)
Ft <- as.matrix(rep(0,dim(Et)[1]))
}

Igrt <-which (xxt==-1)

if (length(Igrt)==0){
Gt<-NULL
Ht<-NULL
} else {
Gt<-c()
for (m in 1:dim(xxt)[1])
{
if (xxt[m,1]==-1){
Gvect <-rep(0,dim(xxt)[1])
Gvect[m] <- -1
Gt<-rbind(Gt,Gvect)
}
}
Gt<-as.matrix(Gt)
Ht <- as.matrix(rep(0,dim(Gt)[1]))
}

#------
IIt <- as.matrix(cbind(diag(dim(xxt)[1]),-diag(dim(xxt)[1])))

Dmatt  <- t(IIt) %*% t(At) %*% At %*% IIt

diag(Dmatt) <- diag(Dmatt) + 1e-8
Tolt <- sqrt(.Machine$double.eps)

if (!is.null(Et)){
Et <- Et %*% IIt}

if (!is.null(Gt)){
Gt <- Gt %*% IIt}

Amatt  <- t(rbind(Et, Gt, diag(2*dim(xxt)[1])))

G2t <- as.matrix(rep(0,2*dim(xxt)[1]))

bvect  <- c(Ft,Ht,G2t)

if (!is.null(Et)){
Neqt <- dim(Et)[1]
} else {
Neqt <- 0
}

dvect <- t(t(Bt) %*% At %*% IIt - 0.5*lambda[i])

coet <- solve.QP(Dmatt, dvect, Amatt, bvect, meq=Neqt)
#coet <- solve.QP(Dmatt, dvect, Amatt, bvect)

sollent<-length(coet$solution)
coemt <- matrix(coet$solution[1:(sollent/2)]-coet$solution[(sollent/2+1):sollent],pt,byrow=T)

coemt[which(abs(coemt) < Tolt)] <- 0

rownames(coemt)<-nnrowt
colnames(coemt)<-nncolt

expj1 <- c()
for (m in 1:length(colnames(coemt))){
   for (n in 1:length(rownames(expj1time))){
       if (rownames(expj1time)[n] == colnames(coemt)[m]){
           expj1 <- c(expj1,expj1time[n])
           break}
       
       }
     }

expj <- c()
for (m in 1:length(rownames(coemt))){
   for (n in 1:length(rownames(expjtime))){
       if (rownames(expjtime)[n] == rownames(coemt)[m]){
           expj <- c(expj,expjtime[n])
           break}
       
       }
    }

predresj <- predresj + sum ((coemt %*% expj1 - expj)^2)

}

predres <- c(predres,predresj)

}
####### up lambda

optlambda <- lambda[which.min(predres)]

dvec <- t(t(B) %*% A %*% II - 0.5*optlambda)
coe <- solve.QP(Dmat, dvec, Amat, bvec, meq=Neq)

sollen<-length(coe$solution)
coem <- matrix(coe$solution[1:(sollen/2)]-coe$solution[(sollen/2+1):sollen],p,byrow=T)
coem[which(abs(coem) < Tol)] <- 0

rownames(coem)<-nnrow
colnames(coem)<-nncol

coem2adj<-t(coem)
write.table(coem2adj,'exp.net.res') # modification
